/* example/test program for the clwp library */
/* C.M. Moerman, June 2002 (c) */
/* This is a basic thread start/run/kill example, generating
   4 threads, including 2 different priorities */

#include "../clwp.h"
#include <stdio.h>

#define MAX_PROC 4

void proc(void *param)  /* this proc will be started as thread */
{   while(1)            /* multiple times in parallel */
    {   printf("PROC %d\n", *((int *) param) );    
        clwpYield();    /* switch to next thread */
    }
}

int main()
{
    volatile int i;
    int ids[MAX_PROC];  /* to store thread IDs */

    int a=1,b=2,c=3,d=4;

    printf("\nCLWP: Example1.\n");
    printf("This program spawns 4 threads that each print messages.\n");
    fflush(stdout);

    if(clwpInit(1))     /* initialise the threading system */
    {                   /* and create 4 extra threads */
        ids[0] = clwpSpawn(proc, &a, 4096, 1, TRUE);
        ids[1] = clwpSpawn(proc, &b, 4096, 2, TRUE);
        ids[2] = clwpSpawn(proc, &c, 4096, 1, TRUE);
        ids[3] = clwpSpawn(proc, &d, 4096, 1, TRUE);

        for(i=0;i<5;i++) /* go looping, activating all threads */
        {
            printf("MAIN %d\n", i); clwpYield();
        }

        clwpKill(ids[0]);
        clwpKill(ids[1]);
        clwpKill(ids[2]);
        clwpKill(ids[3]);
    }
    printf("Ready, status = %d\n", clwpLastError);
    return(0);
}

/* end of file */
