/* example/test program for the clwp library */
/* C.M. Moerman, June 2002 (c) */
/* This is a demo for thread suspend/resume/kill control */

#include "../clwp.h"
#include <stdio.h>

#define MAX_PROC 4

void proc(void *p)      /* this proc will be started as thread */
{   while(1)            /* multiple times in parallel */
    {   printf(" %d ", *((int *) p) );    
        clwpYield();    /* switch to next thread */
    }
}

int main()
{
    volatile int i;
    int ids[MAX_PROC];  /* to store thread IDs */

    int a=0,b=1,c=2,d=3;

    printf("\nCLWP: Example2.\n");
    printf("This program test the Suspend/Resume/Kill functionse.\n");
    fflush(stdout);

    if(clwpInit(1))     /* initialise the threading system */
    {                   /* and create 4 extra threads */
        ids[0] = clwpSpawn(proc, &a, 4096, 1, TRUE);
        ids[1] = clwpSpawn(proc, &b, 4096, 2, TRUE);
        ids[2] = clwpSpawn(proc, &c, 4096, 1, TRUE);
        ids[3] = clwpSpawn(proc, &d, 4096, 1, TRUE);

        for(i=0;i<10;i++) /* go looping, activating all threads */
        {
            printf("\nMAIN(%d) ", i); clwpYield();
            if(i==5) clwpKill(ids[2]);
            if(i==3) clwpThreadSuspend(ids[3]);
            if(i==7) clwpThreadResume(ids[3]);
        }

        clwpKill(ids[0]);
        clwpKill(ids[1]);
        clwpKill(ids[2]);   /* this should give a warning message */
        clwpKill(ids[3]);
    }
    printf("Ready, status = %d\n", clwpLastError);
    return(0);
}

/* end of file */
