/* example/test program for the clwp library */
/* C.M. Moerman, June 2002 (c) */
/* This is a basic semaphore sharing demo */

#include "../clwp.h"
#include <stdio.h>

#define MAX_PROC 2
    int mutex;

void proc(void *p)      /* this proc will be started as thread */
{   while(1)            /* multiple times in parallel */
    {   if(*(int *)p==1)  clwpLockMutex(&mutex);
        if(*(int *)p==1)  clwpReleaseMutex(&mutex);
        printf("PROC %d\n", *((int *) p) );
        clwpYield();    /* switch to next thread */
    }
}

int main()
{
    volatile int i;
    int ids[MAX_PROC];  /* to store thread IDs */

    int a=1,b=2;

    printf("\nCLWP: Example3.\n");
    printf("This program test mutex semaphores.\n");
    fflush(stdout);

    if(clwpInit(1))     /* initialise the threading system */
    {                   /* and create 4 extra threads */
        if(!clwpCreateMutex(&mutex))
            printf("Could not allocate mutex...\n");
            
        ids[0] = clwpSpawn(proc, &a, 4096, 1, TRUE);
        ids[1] = clwpSpawn(proc, &b, 4096, 2, TRUE);

//      clwpDump();
        for(i=0;i<10;i++) /* go looping, activating all threads */
        {
            if(i==2) clwpLockMutex(&mutex);
            if(i==8) clwpReleaseMutex(&mutex);
            printf("MAIN (%d)\n", i); clwpYield();
        }
        if(!clwpDeleteMutex(&mutex)) 
            printf("Could not delete mutex...\n");
        
        clwpKill(ids[0]);
        clwpKill(ids[1]);
    }
    printf("Ready, status = %d\n", clwpLastError);
    return(0);
}

/* end of file */

