/* example/test program for the clwp library */
/* C.M. Moerman, June 2002 (c) */
/* This is a basic test of suicide. Compile with -DDEBUG */

#include "../clwp.h"
#include <stdio.h>

#define MAX_PROC 3
int counter;

void proc(void *p)      /* this proc will be started as thread */
{   while(1)            /* multiple times in parallel */
    {   printf("PROC %d\n", *((int *) p) );
    
        if((*(int *)p==1) & (counter == 1))  clwpKill(clwpGetpid());
        
        if((*(int *)p==2) & (counter == 2))  return; /* also kills */
        
        clwpYield();    /* switch to next thread */
    }
}

int main()
{
    volatile int i;
    int ids[MAX_PROC];  /* to store thread IDs */

    int a=1,b=2,c=3;

    printf("\nCLWP: Example5.\n");
    printf("This program is a thread suicide test.\n");
    fflush(stdout);

    if(clwpInit(1))     /* initialise the threading system */
    {                   /* and create 4 extra threads */
        ids[0] = clwpSpawn(proc, &a, 4096, 1, TRUE);
        ids[1] = clwpSpawn(proc, &b, 4096, 1, TRUE);
        ids[2] = clwpSpawn(proc, &c, 4096, 1, TRUE);

//      clwpDump();
        for(i=0;i<5;i++) /* go looping, activating all threads */
        {
            printf("MAIN (%d)\n", i); clwpYield();
            counter++;
        }
        
        clwpKill(ids[0]);  /* this thread should be dead, so give warning */
        clwpKill(ids[1]);  /* this thread should be dead, so give warning */
        clwpKill(ids[2]);
    }
    printf("Ready, status = %d\n", clwpLastError);
    return(0);
}

/* end of file */

