@echo off
rem generate clwp test code and run verification
rem C.M. Moerman, June 2002

rem add path to compiler if needed...
rem set path=C:\Dev_Cpp4\bin;%path%

rem check to see if we have environment space available
set clwp_err=xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
if [%clwp_err%]==[xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx] goto :ok
echo Please increase environment space
pause
goto :end

:ok

rem generate objects
make all

rem set up for testing again checked result files
set clwp_err=
IF EXIST *.tst del *.tst

rem test: run examples, catch output and verify against reference

test_clwp >test_clwp.tst
diff test_clwp.tst test_clwp.ver >clwp.log
if errorlevel 1 set clwp_err=Mismatch test_clwp

example1 >example1.tst
diff example1.tst example1.ver >clwp.log
if errorlevel 1 set clwp_err=Mismatch example 1

example2 >example2.tst
diff example2.tst example2.ver >clwp.log
if errorlevel 1 set clwp_err=%clwp_err% Mismatch example 2

example3 >example3.tst
diff example3.tst example3.ver >clwp.log
if errorlevel 1 set clwp_err=%clwp_err% Mismatch example 3

example5 >example5.tst
diff example5.tst example5.ver >clwp.log
if errorlevel 1 set clwp_err=%clwp_err% Mismatch example 5

rem Check for accumulated errors and report
if "[%clwp_err%]"=="[]" echo No problems found in verification
if "[%clwp_err%]"=="[]" del clwp.log
if "[%clwp_err%]"=="[]" goto :end

echo Problems found in verification
echo %clwp_err%
set clwp_err=
pause

rem end of batch file
:end

